#!/bin/sh

PIDFILE=/var/run/secureadmin.pid
ETCDIR=/var/etc/secureadmin
PRIVKEY=$ETCDIR/privkey.pem
CRTFILE=$ETCDIR/cert.pem
ADDR=$(nvram get wifi_ipaddr)

secureadmin_needregen() {
  test -d $ETCDIR || mkdir -p $ETCDIR
  secureadmin_mketc
  [ ! -f $PRIVKEY -o ! -f $CRTFILE ]
}

secureadmin_genstuff() {
  test -d $ETCDIR || mkdir -p $ETCDIR
  rm -f $PRIVKEY $CRTFILE
  xrelayd -f -K -U"CN=$ADDR" -p $PRIVKEY -A $CRTFILE
}

secureadmin_setnvram() {
  /usr/sbin/nvram set ff_secureadmin_cert="$(sed -e'/-/d' $CRTFILE)" set ff_secureadmin_privkey="$(sed -e'/-/d' $PRIVKEY)"
}

secureadmin_mketc() {
  if [ 13 -le $(/usr/sbin/nvram get ff_secureadmin_privkey|wc -l) ]; then
    cat>$PRIVKEY<<EOF
-----BEGIN RSA PRIVATE KEY-----
$(/usr/sbin/nvram get ff_secureadmin_privkey)
-----END RSA PRIVATE KEY-----
EOF
  fi
  if [ 9 -le $(/usr/sbin/nvram get ff_secureadmin_cert|wc -l) ]; then
				cat>$CRTFILE<<EOF
-----BEGIN CERTIFICATE-----
$(/usr/sbin/nvram get ff_secureadmin_cert)
-----END CERTIFICATE-----
EOF
  fi
}

